# 3.5.20. sourcedproperties

resource type: sourcedproperties
  Attributes:

    [] (object) –

    Each key of this map is the name of a defined property. The value consists of a (value, source) tuple

    - `1` (OrderedDict({‘type’: ‘string’, ‘description’: ‘source of the property’}))

    - `2` (OrderedDict({‘type’: ‘integer | string | object | array | boolean’, ‘description’: ‘value of the property’}))

User-specified properties for this change, represented as an object mapping keys to (value, source) tuples

Properties are present in several data resources, but have a separate endpoints, because they can represent a large dataset.

## 3.5.20.1. Update Methods

All update methods are available as attributes of `master.data.updates`.

class buildbot.data.properties.Properties
  setBuildProperty(buildid, name, value, source)
    Parameters:

      - buildid (integer) – build ID

      - name (unicode) – name of the property to set

      - value (Any JSON-able type is accepted (lists, dicts, strings and numbers)) – value of the property

      - source (unicode) – source of the property to set

    Set a build property. If no property with that name exists in that build, a new property will be created.

  setBuildProperties(buildid, props)
    Parameters:

      - buildid (integer) – build ID

      - props (IProperties) – name of the property to set

    Synchronize build properties with the db. This sends only one event in the end of the sync, and only if properties changed. The event contains only the updated properties, for network efficiency reasons.

## 3.5.20.2. Endpoints

path: /builders/{builderid_or_buildername}/builds/{build_number}/properties
  Path Keys:

    - builderid_or_buildername (number|string) – the ID or name of the builder

    - build_number (number) – the number of the build within the builder

This path selects all properties of a build

`GET`
  `returns`

    `collection` of `sourcedproperties`

path: /builds/{buildid}/properties
  Path Keys:

    buildid (number) – the id of the build

This path selects all properties of a build

`GET`
  `returns`

    `collection` of `sourcedproperties`

path: /buildsets/{bsid}/properties
  Path Keys:

    bsid (identifier) – the id of the buildset

This path selects all properties of a buildset. Buildset properties are part of the initial properties of a build.

`GET`
  `returns`

    `collection` of `sourcedproperties`